


export class FileEditPopup {
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="javascript:void(0)" [onclick]="widget.close" class="fa fa-times-circle"></a>
				
				<a href="javascript:void(0);" [onclick]="widget.deleteFile" class="fa fa-trash"></a>
				
				<a href="javascript:void(0);" [onclick]="widget.saveFile" class="fa fa-save"></a>
			</div>
			<h1>Bestand gegevens</h1>
		</div>

		<form id="frmFile">
		
			<div ez-if="file.dbFileId == null">Loading...</div>
			
			<div ez-if="file.dbFileId != null">
				
				<div class="action-box">
					<span ez-if="desktopMode == true"><a href="javascript:void(0);" id="btnOpenFile" [widget]="widget" onclick="widget.openFileClick();">Open bestand</a></span>
					
					<span ez-if="desktopMode == false"><a href="javascript:void(0);" id="btnOpenFile" [widget]="widget" onclick="widget.downloadFileClick();">Download bestand</a></span>
				</div>
				<hr/>
				
				<ez-string name="originalFilename" label="Bestandsnaam" [value]="file.originalFilename"></ez-string>
				<ez-string name="size" label="Grootte" [value]="file.size"></ez-string>
				
				<ez-text name="refDescription" label="Reference" [value]="file.refDescription"></ez-text>
				<ez-textarea name="note" label="Notitie" [value]="file.note"></ez-textarea>
				
				<ez-datetime-text name="created" label="Aangemaakt op" [value]="file.created"></ez-datetime-text>
				
			</div>
			
		</form>
	`;
	
	isNew = true;
	
	
	file = {
		dbFileId:       null,
		refDescription: '',
		note:           ''
	};
	
	container = null;
	
	callback_close = null;
	
	saveClicked = false;
	
	setCallbackClose( c ) { this.callback_close = c; }
	
	
	setDbFileId(id) {
		this.file.dbFileId = id;
		
		this.loadFile( id );
	}
	
	loadFile(id) {
		
		postUrl( '/service/files.do', {
			a: 'view',
			dbFileId: id
		}).then( async function(e) {
			let json = await e.json();
			console.log( json );
			this.file = json.file;
			
			this.render();
		}.bind(this));
	}
	
	
	saveFile() {
		let data = {};
		data.a = 'saveSettings';
		data.dbFileId       = this.file.dbFileId;
		data.refDescription = $('input[name=refDescription]').val();
		data.note           = $('textarea[name=note]').val();
		
		showLoadingForm( '#frmFile' );
		this.saveClicked = true;
		postUrl('/service/files.do', data).then( async function(e) {
			let json = await e.json();
			if (json.success) {
				reportUserMessage('Wijzigingen opgeslagen');
			}
			
			close_popup();
		}.bind(this) );
		
	}
	
	deleteFile() {
		showConfirmation('Verwijderen', 'Weet je zeker dat je dit bestand wilt verwijderen?', function() {
			
			postUrl( '/service/files.do', {
					a: 'delete'
					, 'dbFileId' : this.file.dbFileId
				}).then( async function(e) {
					let json = await e.json();
					close_popup();
					
					if (this.callback_close) {
						this.callback_close();
					}
					reportUserMessage( 'Bestand verwijderd' );
				}.bind(this) );
				
		}.bind(this));
	}
	
	render() {
		if (!this.container) {
			this.container = show_popup('Bestand aanpassen', '');
			this.container.get(0).close_callback = function() {
				if (this.saveClicked && this.callback_close) {
					this.callback_close();
				}
			}.bind(this);
		}
		
		let ezTpl = new EzTemplate( this.container );
		ezTpl.loadHtml( this.tpl );
		ezTpl.setVar('desktopMode', toolboxConfig.desktopMode == 1 ? true : false);
		ezTpl.setVar('file', this.file);
		ezTpl.setObject('widget', this);
		ezTpl.render();
	}
	
	openFileClick( dbFileId ) {
		postUrl( '/service/files.do', {
			a: 'openFile',
			dbFileId: this.file.dbFileId
		});
	}
	
	downloadFileClick( dbFileId ) {
		window.open( appUrl('/service/files.do') + '?a=downloadFile&dbFileId=' + this.file.dbFileId);
	}
	
	
	close() {
		close_popup();
	}
	
	show() {
		this.render();
	}
	
	
}

