

export class UserListWidget {

	ezTpl = null;
	
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/')}}" class="fa fa-chevron-circle-left"></a>
				<a href="{{appUrl('/masterdata/users/edit/')}}" class="fa fa-plus"></a>
			</div>
			<h1>Gebruikers</h1>
		</div>
		
		<div ez-if="users == null">
			Loading...
		</div>
		<div ez-if="users != null">
			<table class="table">
				<thead>
					<tr>
						<th>Gebruikersnaam</th>
						<th>Volledige naam</th>
						<th>E-mail</th>
						<th></th>
					</tr>
				</thead>
				<tbody ez-for="users" ez-item="u">
					<tr [onclick]=widget.editUser class="pointer">
						<td user-id="{{u.userId}}">
							{{u.username}}
						</td>
						<td>{{u.firstname}} {{u.lastname}}</td>
						<td>{{u.email}}</td>
						<td class="actions">
							<a href="{{appUrl('/masterdata/users/edit/?id='+u.userId)}}" class="fa fa-pencil"></a>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	`;
	
	editUser(evt, tr) {
		let uid = tr.querySelector('[user-id]').getAttribute('user-id');
		
		gotoRoute( appUrl('/masterdata/users/edit/?id='+uid) );
	}
	
	loadUsers() {
		postUrl( '/service/users.do' ).then( async function(e) {
			let json = await e.json();
			if (json.error) {
				showErrorWidget( json );
			}
			

			this.ezTpl.setObject('widget', this);
			
			this.ezTpl.setVar('users', json.objects);
			
			this.ezTpl.render();
		}.bind(this) );
	}
	
	
	
	init(e) {
		this.ezTpl = new EzTemplate( e );
		this.ezTpl.setVar('users', null);
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
		
		this.loadUsers();
	}
	
}

