



export class SlotplanConfigWidget {
	
	
	tpl = `
		<div class="page-header">
			<div class="toolbox">
				<a href="{{appUrl('/masterdata/sales/slotplan/')}}" class="fa fa-chevron-circle-left"></a>
				<span ez-if="isNew == false">
					<a href="javascript:void(0);" [onclick]="widget.deleteSlotplan" class="fa fa-trash"></a>
				</span>
				<a href="javascript:void(0);" [onclick]="widget.saveSlotplan" class="fa fa-save"></a>
			</div>
			
			<h1>Slot plan aanmaken</h1>
		</div>
		
		<fieldset class="base-settings">
			<legend>Instellingen</legend>
			
			<div style="display: flex;">
				<ez-text name="name" label="Naam" [value]="slotplan.name" ></ez-text>
				
				&nbsp;&nbsp;
				
				<ez-select name="defaultSlotType" label="Slot type" [value]="slotplan.defaultSlotType">
					<option value="hour">Uur</option>
					<option value="day">Dag</option>
					<option value="week">Week</option>
					<option value="month">Maand</option>
				</ez-select>
				
				&nbsp;&nbsp;
				
				<span class="input-hours-in-day hidden">
					Uren in dag
					&nbsp;&nbsp;
					<ez-number name="startHour" min="0" max="23" [value]="slotplan.startHour"></ez-number>
					<ez-number name="endHour" min="0" max="23" [value]="slotplan.endHour"></ez-number>
				</span>
			</div>
		</fieldset>
		
		<hr/>
		
		<fieldset class="fieldset-slotplanning">
			<legend>Slotplanning</legend>
			
			<div id="planning-container"></div>
			
		</fieldset>
	`;
	
	
	tplHour = `
		<div id="slotselection-status">&nbsp;</div>
		
		<div class="slotplan-slotitem-container">
			<div id="slotplan-container">
				<div class="slotplan-hour-container">
					<div class="slotplan-hour-header">
						<div class="hour-entry-header">
							<div class="caption"></div>
							<div class="cell-1">Maandag</div>
							<div class="cell-2">Dinsdag</div>
							<div class="cell-3">Woensdag</div>
							<div class="cell-4">Donderdag</div>
							<div class="cell-5">Vrijdag</div>
							<div class="cell-6">Zaterdag</div>
							<div class="cell-7">Zondag</div>
						</div>
					</div>
					<div class="slotplan-hour" ez-for="hours" ez-item="h">
						<div class="hour-entry hour-entry-{{h.hour}}" hour="{{h.hour}}">
							<div class="caption">{{ h.hour }}.00</div>
							<div class="hour-cell cell-1" dayno="1"></div>
							<div class="hour-cell cell-2" dayno="2"></div>
							<div class="hour-cell cell-3" dayno="3"></div>
							<div class="hour-cell cell-4" dayno="4"></div>
							<div class="hour-cell cell-5" dayno="5"></div>
							<div class="hour-cell cell-6" dayno="6"></div>
							<div class="hour-cell cell-7" dayno="7"></div>
						</div>
					</div>
				</div>
			</div>
			
			<div id="slotitem-hour-edit-container" class="hidden">
				<h2>Slot bewerken</h2>
				
				<table>
					<tr>
						<th><label for="si-day-1">Ma</label></th>
						<th><label for="si-day-2">Di</label></th>
						<th><label for="si-day-3">Wo</label></th>
						<th><label for="si-day-4">Do</label></th>
						<th><label for="si-day-5">Vr</label></th>
						<th><label for="si-day-6">Za</label></th>
						<th><label for="si-day-7">Zo</label></th>
					</tr>
					<tr>
						<td><input type="checkbox" class="si-day" id="si-day-1" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-2" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-3" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-4" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-5" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-6" /></td>
						<td><input type="checkbox" class="si-day" id="si-day-7" /></td>
					</tr>
				</table>
				
				<ez-time name="startTime" label="Starttijd"></ez-time>
				
				<ez-number name="duration" min="5" name="duration" label="Duur"></ez-number>
				
				<ez-select name="pricetypeId" label="Prijstype" value="" [options]="pricetypes"></ez-select>
				
				
				<div style="margin-top: 15px;">
					<input type="button" class="btn-si-cancel" value="Annuleer" />
					<input type="button" class="btn-si-delete" value="Delete" />
					<input type="button" class="btn-si-save" value="Opslaan" />
				</div>
			</div>
		</div>
		
		<div id="slotitem-records"></div>
	`;

	tplDay = `
		<table class="tbl-day">
			<thead>
				<th>Maandag</th>
				<th>Dinsdag</th>
				<th>Woensdag</th>
				<th>Donderdag</th>
				<th>Vrijdag</th>
				<th>Zaterdag</th>
				<th>Zondag</th>
			</thead>
			
			<tbody>
				<tr>
					<td class="td-1">
						<input type="checkbox" class="days-planned" day="1" name="day1-checked" [checked]="{{slotitemDays[1].active}}" />
						<ez-select name="day1-pricetype" label="Prijstype" [value]="slotitemDays[1].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-2">
						<input type="checkbox" class="days-planned" day="2" name="day2-checked" [checked]="{{slotitemDays[2].active}}" />
						<ez-select name="day2-pricetype" label="Prijstype" [value]="slotitemDays[2].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-3">
						<input type="checkbox" class="days-planned" day="3" name="day3-checked" [checked]="{{slotitemDays[3].active}}" />
						<ez-select name="day3-pricetype" label="Prijstype" [value]="slotitemDays[3].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-4">
						<input type="checkbox" class="days-planned" day="4" name="day4-checked" [checked]="{{slotitemDays[4].active}}" />
						<ez-select name="day4-pricetype" label="Prijstype" [value]="slotitemDays[4].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-5">
						<input type="checkbox" class="days-planned" day="5" name="day5-checked" [checked]="{{slotitemDays[5].active}}" />
						<ez-select name="day5-pricetype" label="Prijstype" [value]="slotitemDays[5].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-6">
						<input type="checkbox" class="days-planned" day="6" name="day6-checked" [checked]="{{slotitemDays[6].active}}" />
						<ez-select name="day6-pricetype" label="Prijstype" [value]="slotitemDays[6].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
					<td class="td-7">
						<input type="checkbox" class="days-planned" day="7" name="day7-checked" [checked]="{{slotitemDays[7].active}}" />
						<ez-select name="day7-pricetype" label="Prijstype" [value]="slotitemDays[7].slotplanPricetypeId" [options]="pricetypes"></ez-select>
					</td>
				</tr>
			</tbody>
		</table>

		<div style="font-style: italic; margin-top: 25px;">
			Dagen die kunnen worden ingepland
		</div>
	`;
	
	
	tplWeek = `
		<div>
			<ez-select name="pricetypeIdWeek" label="Prijstype" [value]="slotplan.pricetypeIdWeek" [options]="pricetypes"></ez-select>
		</div>
	`;
	
	tplMonth = `
		<div>
			<ez-select name="pricetypeIdMonth" label="Prijstype" [value]="slotplan.pricetypeIdMonth" [options]="pricetypes"></ez-select>
		</div>
	`;
	
	slotIdCounter=1;
	
	container = null;
	ezTpl = null;
	isNew = true;
	
	minuteJumps = 15;
	
	pricetypes = null;
	
	
	slotplanId = null;
	slotplan = {
		name: '',
		startHour: 6,
		endHour: 20
	};
	
	slotitemHour = null;			// current item that's being edited
	
	hourSlots = [];
	
	
	init(e) {
		this.container = e;
		
		this.slotplanId = getUrlParam( 'id' );
		
		this.loadBaseData();
	}
	
	loadBaseData() {
		postUrl('/service/sales/slot/config.do', {
			a: 'baseData'
		}).then( async function(e) {
			let json = await e.json();
				
//				this.pricetypes = json.pricetypes;
			this.pricetypes = [];
			for(let i in json.pricetypes) {
				let pt = json.pricetypes[i];
				this.pricetypes.push({
					value: pt.slotplanPricetypeId,
					text: pt.name
				});
			}
			
			
			if (this.slotplanId) {
				this.isNew = false;
				this.loadSlotplan( this.slotplanId );
			}
			else {
				this.render();
			}
		}.bind(this) );
	}
	
	
	
	loadSlotplan( id ) {
		
		postUrl('/service/sales/slot/config.do', {
			a: 'view',
			slotplanId: id
		}).then( async function(e) {
			let json = await e.json();
			
			this.slotplan = json.slotplan;
			
			this.hourSlots = [];
			
			for(let i in this.slotplan.slotitemHours) {
				let si = this.slotplan.slotitemHours[i];
				
				si.id = 'si-' + this.uniqueId();
				
				let toks = si.startTime.split(':');
				si.hour = parseInt(toks[0]);
				si.minute = parseInt(toks[1]);
				si.pricetypeId = si.slotplanPricetypeId;
				
				this.hourSlots.push( si );
			}
			
			this.render();
		}.bind(this) );
		
	}
	
	
	
	render() {
		this.ezTpl = new EzTemplate( this.container );
		this.ezTpl.setVar('isNew', this.isNew);
		this.ezTpl.setVar('slotplan', this.slotplan);
		this.ezTpl.setObject('widget', this);
		
		this.ezTpl.loadHtml( this.tpl );
		this.ezTpl.render();
		
		$('ez-select select[name=defaultSlotType]').on('change', function() {
			this.updateSlotplanning();
		}.bind(this));
		this.updateSlotplanning();
		
		$('.input-hours-in-day input[type=number]').on('change', function() {
			this.updateHoursHourplan();
		}.bind(this));
	}
	
	
	uniqueId() {
		return this.slotIdCounter++;
	}
	
	
	updateSlotplanning() {
		let slottype = $('select[name=defaultSlotType] option:selected').get(0).value;
		console.log('slottype', slottype);
		
		$('.input-hours-in-day').hide();
		$('.fieldset-slotplanning').show();
		
		if (slottype == 'hour') {
			this.renderHourPlan();
			this.renderHourSlots();
		}
		else if (slottype == 'day') {
			this.renderDayPlan();
		}
		// week
		else if (slottype == 'week') {
			this.renderWeekPlan();
		}
		// month
		else if (slottype == 'month') {
			this.renderMonthPlan();
		}
		else {
			$('.fieldset-slotplanning').hide();
		}
	}
	
	
	
	renderDayPlan() {
		let c = document.querySelector( '#planning-container' );
		let ht = new EzTemplate( c );
		
		let days = {};
		for(let i=1; i <= 7; i++) {
			days[i] = {};
		}
		
		if ( this.slotplan && this.slotplan.slotitemDays ) {
			for(let i in this.slotplan.slotitemDays) {
				let sid = this.slotplan.slotitemDays[i];
				days[ sid.dayno ] = sid;
			}
		}
//				ht.setVar('slotitemDays' + sid.dayno, sid);
		
		
		console.log('days', days);
		ht.setVar('slotitemDays', days);
		ht.setVar('pricetypes', this.pricetypes);
		ht.loadHtml( this.tplDay );
//		console.log(this.tplDay);
		ht.render();
	}
	
	renderWeekPlan() {
		let c = document.querySelector( '#planning-container' );
		
		let ht = new EzTemplate( c );
		ht.setVar('slotplan', this.slotplan);
		ht.setVar('pricetypes', this.pricetypes);
		ht.loadHtml( this.tplWeek );
		ht.render();
	}
	
	renderMonthPlan() {
		let c = document.querySelector( '#planning-container' );
		
		let ht = new EzTemplate( c );
		ht.setVar('slotplan', this.slotplan);
		ht.setVar('pricetypes', this.pricetypes);
		ht.loadHtml( this.tplMonth );
		ht.render();
	}
	
	
	
	
	renderHourPlan() {
		$('.fieldset-slotplanning').show();
		$('.input-hours-in-day').css('display', 'flex');
		
		// build hour list
		let hours = [];
		for(let i=0; i < 24; i++) {
			hours.push({
				hour: i
			});
		}
		
		
		let c = document.querySelector( '#planning-container' );
		
		let ht = new EzTemplate( c );
		ht.loadHtml( this.tplHour );
		ht.setVar('hours', hours);
		
		console.log(this.pricetypes);
		
		ht.setVar('pricetypes', this.pricetypes);
		ht.render();
		
		$(c).find('.hour-cell').on('click', function() {
			let s = $(c).find('.slotitem-sample');
			
			if (s.length > 0) {
				this.slotHourClick( s );
			}
		}.bind(this));
		
		
		
		
		$('#slotitem-hour-edit-container').find('input[type=checkbox], input[type=number], input[type=text]').on('change dp.change', function() {
			this.slotEditChange();
		}.bind(this));
		
		$(c).find('.btn-si-cancel').on('click', function() {
			this.hideHourEdit();
		}.bind(this));
		
		$(c).find('.btn-si-delete').on('click', function() {
			this.deleteHourEdit();
		}.bind(this));
		
		$(c).find('.btn-si-save').on('click', function() {
			this.saveHourEdit();
			
		}.bind(this));
		
		
		this.updateHoursHourplan();
	}
	
	getStartHour() {
		let minHour = $('input[name=startHour]').val();
		minHour = parseInt(minHour);
		if (isNaN(minHour)) minHour = 0;
		return minHour;
	}
	getEndHour() {
		let maxHour = $('input[name=endHour]').val();
		maxHour = parseInt(maxHour);
		if (isNaN(maxHour)) maxHour = 0;
		return maxHour;
	}
	
	updateHoursHourplan() {
		let startHour = this.getStartHour();
		let endHour = this.getEndHour();
		
		for(let i=0; i < 24; i++) {
			
			if (i < startHour || i > endHour)
				$('.slotplan-hour .hour-entry-'+i).hide();
			else
				$('.slotplan-hour .hour-entry-'+i).show();
		}
		
		$('.slotplan-hour').on('mouseout', function( evt ) {
			if ( $(evt.target).closest('.slotplan-hour').length )
				return;
			console.log('mouseout');
			this.renderSampleHour( evt );
		}.bind(this));
		$('.slotplan-hour').on('mousemove', function( evt ) {
			this.renderSampleHour( evt );
		}.bind(this));
	}
	
	
	renderSampleHour(evt) {
		let t = $(evt.target);
//		console.log(t);

//console.log('jow1');
		
		if ( $(t).hasClass('hour-cell') ) {
//			console.log('jow2');
			let dayno = parseInt( $(t).attr('dayno') );
			if (isNaN(dayno)) return;
			
			let hour = parseInt( $(t).closest('.hour-entry').attr('hour') );
			if (isNaN(hour)) return;
			
			
			let hourCell = null;
			if ( $(evt.target).hasClass('hour-cell') ) {
				hourCell = $(evt.target);
			}
			else if ( $(evt.target).closest('.hour-cell') ) {
				hourCell = $(evt.target).closest('.hour-cell');
			}
			if (hourCell == null || hourCell.length == 0)
				return;
			
			let top = hourCell.offset().top;
			let offsetY = evt.clientY - top;
//			console.log(offsetY);
			
			let minPos = parseInt( 60 / $(evt.target).height() * offsetY );
			minPos += (this.minuteJumps/2);
			if (this.minuteJumps)
				minPos = minPos - (minPos%this.minuteJumps);
			if ( minPos >= 60 ) minPos = 45;
			
			this.renderHourSlot({
				id:       'sample',
				days:     [ dayno ],
				hour:     hour,
				minute:   minPos,
				duration: 60
			})
		}
		else {
//			this.removeHourSlot( 'sample' );
		}
	}
	
	renderEditHour() {
		let si = this.slotHourEditToObject( this.slotitemHour );
		
		this.slotitemHour = si;
		
		this.renderHourSlot( this.slotitemHour );
	}
	
	renderHourSlots() {
		$('.slotplan-hour-container .slotitem').remove();
		
		for(let i in this.hourSlots) {
			let hs = this.hourSlots[i];
			
			this.renderHourSlot( hs );
		}
		
	}
	
	renderHourSlot( opts ) {
		
		// remove old
		let slotitems = $('.slotplan-hour-container').find('.slotitem-'+opts.id);
		slotitems.remove();
		
		for(let i in opts.days) {
			let dayno = opts.days[i];
			
			let slotitem = $('<div class="slotitem" />');
			
			slotitem.addClass( 'slotitem-' + opts.id );
			
			if (opts.id == 'sample') {
				slotitem.addClass('slotitem-sample');
				
				slotitem.on('click', function() {
					this.slotHourClick( slotitem );
				}.bind(this));
			}
			
			slotitem.data('slotitem', opts);
			
			slotitem.data('id', opts.id);
			slotitem.data('dayno', dayno);
			slotitem.data('hour', opts.hour);
			slotitem.data('minute', opts.minute);
			slotitem.data('duration', opts.duration);
			
			slotitem.css('left', 80 * dayno);
			
			let cellHeight = $('.slotplan-hour-container .hour-entry-'+this.getStartHour()+' .hour-cell').outerHeight()+1;
			
			let top = $('.slotplan-hour-header').outerHeight() + (( opts.hour - this.getStartHour() ) * cellHeight);
			if (opts.minute) {
				top += (cellHeight / 60 * opts.minute);
			}
			
			slotitem.css('top', top);
			
			if (opts.id == 'sample') {
				slotitem.css('height', 2);
			}
			else {
				let height = opts.duration / 60 * cellHeight;
				slotitem.css('height', height);
			}
			
			slotitem.on('click', function(evt) {
				this.slotHourClick( evt.target );
			}.bind(this));
			
			
//			console.log('adding slot thing');
			$('.slotplan-hour-container').append( slotitem );
		}
		$('#slotselection-status').text( _('dayno.' + opts.days[0]) + ' ' + format_time(opts.hour, opts.minute) );
	}
	
	removeHourSlot( id ) {
		let slotitems = $('.slotplan-hour-container .slotitem');
		for(let i=0; i < slotitems.length; i++) {
			let si = $( slotitems.get(i) );
			
			if (si.data('id') == id) {
				si.remove();
			}
		}
	}
	
	slotHourClick(slotitem) {
		slotitem = $(slotitem);
		
		this.slotitemHour = slotitem.data('slotitem');
		console.log( this.slotitemHour );
		
		let c = $('#slotitem-hour-edit-container');
		
		let newItem = false;
		if (slotitem.data('id') == 'sample') {
			newItem = true;
			
			this.slotitemHour.id = 's-' + this.uniqueId();
			
			c.find('input[type=checkbox]').prop('checked', false);
		}
		
		c.removeClass('hidden');
		
		c.find('.si-day').prop('checked', false);
		
		if (this.slotitemHour.days) for(let i in this.slotitemHour.days) {
			c.find('#si-day-' + this.slotitemHour.days[i]).prop('checked', true);
		}
		c.find('input[name=startTime]').val( format_time(slotitem.data('hour'), slotitem.data('minute')) );
		c.find('input[name=duration]').val( slotitem.data('duration') );
		
		if (this.slotitemHour.pricetypeId)
			c.find('select[name=pricetypeId]').val( this.slotitemHour.pricetypeId );
		
		
		if (newItem) {
			this.hourSlots.push( this.slotitemHour );
//			this.renderHourSlot(this.slotitemHour);
		}
		
		this.renderEditHour();
	}
	
	
	slotHourEditToObject( opts ) {
//		id:       'sample',
//				dayno:    dayno,
//				hour:     hour,
//				minute:   minPos,
//				duration: 60

		opts = opts ? opts : {};
		if (!opts.id)
			opts.id = 'si-' + this.uniqueId();
		
		
		let c = $('#slotitem-hour-edit-container');
		
		let si = {};
		si.id = opts.id;
		si.days = [];
		
		si.startTime = $('input[name=startTime]').val();
		
		let toks = si.startTime.split(':');
		si.hour = parseInt(toks[0]);
		if (isNaN(si.hour) || si.hour < 0 || si.hour > 23)
			si.hour = 8;
		
		si.minute = parseInt(toks[1]);
		if (isNaN(si.minute) || si.minute < 0 || si.minute > 60)
			si.minute = 0;
		
		si.duration = parseInt( $('input[name=duration]').val() );
		if (isNaN(si.duration) || si.duration < 0)
			si.duration = 30;
		
		
		si.pricetypeId = $('select[name=pricetypeId]').val();
		
		// set days
		for(let i=1; i <= 7; i++) {
			if ( c.find('#si-day-'+i).prop('checked') ) {
				si.days.push( i );
			}
		}
		
		return si;
	}
	
	slotEditChange() {
		let si = this.slotHourEditToObject( this.slotitemHour );
		
		console.log('jow', si);
		
		this.renderHourSlot(si);
		this.renderEditHour();
	}
	
	hideHourEdit() {
		$('#slotitem-hour-edit-container').addClass( 'hidden' );
		
//		this.slotitemHour
		this.renderHourSlots();
	}
	
	deleteHourEdit() {
		
		if ( ! this.slotitemHour )
			this.hideHourEdit();
		
		let newList = [];
		
		for(let i in this.hourSlots) {
			if (this.hourSlots[i].id != this.slotitemHour.id)
				newList.push( this.hourSlots[i] );
		}
		
		
		this.hourSlots = newList;
		this.renderHourSlots();
		
		this.hideHourEdit();
	}
	
	updateHourSlotsEntry( slotitem ) {
		let found = false;
		for(let i in this.hourSlots) {
			if (this.hourSlots[i].id == slotitem.id) {
				this.hourSlots[i] = slotitem;
				found = true;
				break;
			}
		}
		
		if ( found == false ) {
			this.hourSlots.push( slotitem );
		}
	}
	
	saveHourEdit() {
		let s = this.slotHourEditToObject( this.slotitemHour );
//		console.log('save', s);
		
		let errors = [];
		if (s.days.length == 0) {
			errors.push('Geen dag gekozen');
		}
		if (s.duration <= 0) {
			errors.push('Ongeldige duur');
		}
		
		if (errors.length) {
			alert('Error: ' + errors.join(','));
			return;
		}
		
		this.updateHourSlotsEntry( s );
		
//		console.log( this.hourSlots );
		
		$('#slotitem-hour-edit-container').addClass('hidden');
		this.renderHourSlots();
	}
	
	
	
	saveSlotplan() {
		
		let d = {};
		d.a = 'saveSlotplan';
		
		
		let base = $('.base-settings');
		if (this.slotplan.slotplanId)
			d.slotplanId = this.slotplan.slotplanId;
		d.name            = base.find('input[name=name]').val();
		d.defaultSlotType = base.find('select[name=defaultSlotType]').val();
		d.startHour       = base.find('input[name=startHour]').val();
		d.endHour         = base.find('input[name=endHour]').val();
		
		// Edit hour slot open? => save..
		if ($('select[name=defaultSlotType] option:selected').val() == 'hour' && $('#slotitem-hour-edit-container').hasClass('hidden') == false) {
			this.saveHourEdit();
		}
		// slotitems hours
		d.hourSlots = this.hourSlots;
		
		for(let x=1; x <= 7; x++) {
			let vn1 = 'day'+x+'-pricetype';					// vn1 = varname1 ;)
			d[vn1] = $('select[name='+vn1+']').val();
			
			let vn2 = 'day'+x+'-checked';
			d[vn2] = $('input[name='+vn2+']').prop('checked') ? 1 : 0;
		}
		
		
		if ( $('select[name=defaultSlotType]').val() == 'week' ) {
			d.pricetypeIdWeek = $('select[name=pricetypeIdWeek]').val();
		}
		if ( $('select[name=defaultSlotType]').val() == 'month' ) {
			d.pricetypeIdMonth = $('select[name=pricetypeIdMonth]').val();
		}
		
		
		showLoadingForm( '.base-settings' );
		
		postUrl( '/service/sales/slot/config.do', d)
		.then( async function(e) {
			let json = await e.json();
			
			reportUserMessage( 'Wijzigingen opgeslagen' );
			gotoRoute( appUrl('/masterdata/sales/slotplan/config/?id='+json.slotplanId) );
		}.bind(this) );
		
	}
		
	
	deleteSlotplan() {
		showConfirmation('Verwijderen', 'Weet je zeker dat je deze planning wilt verwijderen?', function() {
			
			postUrl('/service/sales/slot/config.do', {
				a: 'deleteSlotplan',
				slotplanId: this.slotplan.slotplanId
			}).then( async function(e) {
				gotoRoute( appUrl('/masterdata/sales/slotplan/') );
			}.bind(this));
			
		}.bind(this));
	}
	
	
	
}


